%TP3 Exo 1

%Consider the polynomial (x- 10^m)(x- 10^-m) = x^2 - (10^m + 10^-m )x + 1
evals= [1,5,10, 15];
borne = length(evals);
errPlus = zeros(1, borne); errMinus = zeros(1, borne);
errRelPlus = zeros(1,borne); errRelMinus = zeros(1, borne);
for i = 1:borne
    m = evals(i);
    x1 = 10^m;
    x2 = 10^(-m);

    b = -x1-x2;
    D = b^2-4;
    y1 = (-b + sqrt(D))/2;
    y2 = (-b - sqrt(D))/2;


    errPlus(1,i) = abs(y1-x1);
    errMinus(1,i) = abs(y2-x2);

    errRelPlus(1,i) = abs(y1-x1)/abs(x1);
    errRelMinus(1,i) = abs(y2-x2)/abs(x2);
end
m=borne;
%plot(linspace(1, m, m), errRelMinus, 'k-', linspace(1,m,m), errMinus, 'g-')

%Netwon method
steps = 10; m=3;
b = -10^m - 10^(-m);
x = 10^(-m);
xpre = 10^m;
errRelNewton = zeros(1,steps); errNewton = zeros(1,steps);
for i = 1:steps
    xnext = xpre - ((xpre^2 + b*xpre + 1)/(2*xpre + b));
    errNewton(1,i) = abs(x - xnext)
    errRelNewton(1,i) = abs(x - xnext)/(x);
end
semilogy(linspace(1,steps,steps), errRelNewton, 'k-', linspace(1,steps,steps), errNewton, 'g-')

%Wilkinson polynomial
% pPrev = [1, -1]
% for j = 2:20
%     pNext = conv(pPrev, [1, -j]);
%     pPrev = pNext;
% end
% p = pNext;
% exponents = [4,8,16];
% r = roots(p);
% plot(real(r), imag(r), 'ko')
% hold on
% for expo = exponents
%     delta = 10^(-expo);
%     perturb = p;
%     perturb(2) = p(2) + delta;
%     r = roots(perturb);
%     plot(real(r), imag(r), 'o')
% end
% % plot(real(r(:,1)), imag(r(:,1)), 'ro', real(r(:,2)), imag(r(:,2)), 'go', real(r(:,3)), imag(r(:,3)), 'bo')
% xlabel('Real(x)'); ylabel('Imag(x)');
% title('Distribution des racines du Polynôme de Wilkinson perturbé');
% legend('\delta = 0', '\delta = 10^{-4}', '\delta = 10^{-8}', '\delta = 10^{-16}')
% hold off
